#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>

#define	BUFSIZE	16384
static	unsigned char	buf[BUFSIZE];

static	unsigned long	hex2str(unsigned char *c, int len)
{
	int	i;
	unsigned long	val;

	val = 0;
	for (i = 0; i < len; i++) {
		if (*c == NULL) break;
		val <<= 4;
		if (*c >= '0' && *c <= '9') val |= *c - '0';
		else if (*c >= 'A' && *c <= 'Z') val |= *c - 'A' + 10;
		else if (*c >= 'a' && *c <= 'z') val |= *c - 'a' + 10;
		c++;
	}
	
	return val;
}

int	main(int argc, char *argv[])
{
	int	result;
	unsigned long	p, o, l, w, c;
	FILE	*f;

	if (argc < 5) {
		printf("usage:	romsave [filename] [window(hex)] [I/O(hex)] [length(hex)] \n");
		printf("	window address c800:0000 -> c8000000\n");
		result = EXIT_FAILURE;
		goto fin0;
	}

	f = fopen(argv[1], "wb");
	p = hex2str(argv[2], 8);
	o = hex2str(argv[3], 8) & 0xffff;
	l = hex2str(argv[4], 8);

	if (f == NULL) {
		printf("file open error!\n");
		result = EXIT_FAILURE;
		goto fin0;
	}

	printf("%04lx:%04lx/%04x, %ld byte\n", (p >> 16) & 0xffff, p & 0xffff, o, l);

	c = 0;
	outp(o + 0x00, 0xe1);	// page 3

	while (l > 0) {
		outp(o + 0x02, c);	// BPAGE
		inp(o + 0x02);		// delay
		inp(o + 0x02);
		inp(o + 0x02);

		w = (l < BUFSIZE) ? l : BUFSIZE;
		memcpy(buf, (unsigned char far *)p, w);

		if (fwrite(buf, 1, w, f) < w) {
			printf("file write error!\n");
			result = EXIT_FAILURE;
			goto fin1;
		}

		l -= w;
		c++;
	}

	result = EXIT_SUCCESS;

 fin1:
	fclose(f);
 fin0:	
	return result;
}
